



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>QGis（三）查询矢量图层的要素属性字段值（转载）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">QGis（三）查询矢量图层的要素属性字段值（转载）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-24 07:25:04 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3><a href="http://www.aiuxian.com/article/p-1646531.html" rel="external nofollow noreferrer">QGis（三）查询矢量图层的要素属性字段值</a></h3>
<p><a href="https://github.com/gwaldron/osgearth/issues/489" rel="external nofollow noreferrer">https://github.com/gwaldron/osgearth/issues/489</a></p>
<p>当加载一个矢量图层后，如果要查看要素的属性字段值，则需要实现identity的功能。可以和前面的缩放一样，添加一个工具栏按钮：</p>
<p>（1）在MainWindow添加一个变量，并在Qt设计师里添加Action：</p>
<div>
<pre class="prettyprint linenums">QgsMapToolSelect *mpIdentifyTool;        ///&lt;查询要素</pre>
</div>
<div>&nbsp;</div>
<p>这里QgsMapToolSelect类继承自QgsMapTool，后面再列出详细内容。</p>
<p>（2）然后在初始化函数里添加：</p>
<div>
<div>
<div>
<div>
<pre class="prettyprint linenums">mpMapToolBar-&gt;addAction(ui.mpActionIdentify);
mpIdentifyTool = new QgsMapToolSelect(mainMapCanvas);
mpIdentifyTool-&gt;setAction(ui.mpActionIdentify);</pre>
</div>
</div>
</div>
</div>
<p>（3）添加信号槽函数连接：</p>
<div>
<pre class="prettyprint linenums">connect(ui.mpActionIdentify, SIGNAL(triggered()), this, SLOT(identifyFeature()));</pre>
</div>
<div>&nbsp;</div>
<p>（4）槽函数实现：</p>
<div>
<pre class="prettyprint linenums">void MainWindow::identifyFeature()
{
    mpIdentifyTool-&gt;SetEnable(true);
    mainMapCanvas-&gt;setMapTool(mpIdentifyTool);
    ui.mpActionIdentify-&gt;setCheckable(true);
    ui.mpActionIdentify-&gt;setChecked(true);
    )-&gt;type() == QgsMapLayer::RasterLayer)
    {
        return;
    }
    QgsVectorLayer *pLayer=(QgsVectorLayer *)mainMapCanvas-&gt;layer();
    mpIdentifyTool-&gt;SetSelectLayer(pLayer);
    if ( ui.mpActionIdentify-&gt;isChecked())
    {
        pLayer-&gt;removeSelection(true);
    }
}</pre>
</div>
<div>&nbsp;</div>
<p>可以看到，基本步骤就跟前面的缩放工具栏一模一样。但是QgsMapToolSelect不是&nbsp;QgsMapTool自带的类，需要自定义，QgsMapToolSelect类的定义如下：</p>
<div>
<pre class="prettyprint linenums">class QgsMapToolSelect :
    public QgsMapTool
{
    Q_OBJECT;
public:
    QgsMapToolSelect(QgsMapCanvas *);
    ~QgsMapToolSelect(void);
public:
    //设置当前被选择(活动)的图层
    void SetSelectLayer(QgsVectorLayer *);
    &lt;span style="white-space:pre"&gt;    &lt;/span&gt;//重载鼠标释放事件函数
    virtual void canvasReleaseEvent(QMouseEvent * e);
    //设定工具状态
    void SetEnable(bool);
    //得到所有的属性和属性值，&lt;属性1，属性值1&gt;是QMap的一对值
    QList&lt;QMap&lt;QString, QString&gt;&gt; GetAttributeValue(QgsVectorLayer *layer, QgsFeatureIds selectedFIds);
    void setShowFlag(bool flag);
    IdentifyResultDlg *ResultDlg();
private:
    QgsVectorLayer* pLayer;
    QgsFeatureIds layerSelectedFeatures;
    bool StatusFlag;
    QList&lt;QMap&lt;QString, QString&gt;&gt; list; //存储选择后的要素
    bool isShowFlag; ///&lt; 是否在主界面上勾选了shp图层
    IdentifyResultDlg *mIdentifyResultDlg;

private:
    &lt;span style="white-space:pre"&gt;    &lt;/span&gt;//提取鼠标位置一定范围作为选择区域
    void ExpandSelectRangle(QRect &amp;Rect,QPoint Point);
    //将指定的设备坐标区域转换成地图坐标区域
    void SetRubberBand(QRect &amp;selectRect,QgsRubberBand *);
    //选择图层特征
        void SetSelectFeatures(QgsGeometry *,bool,bool,bool);
    void SetSelectFeatures(QgsGeometry *,bool);
};</pre>
</div>
<p>具体函数实现：</p>
<div>
<pre class="prettyprint linenums">#include "qgsmaptoolselect.h"

//构造和析构函数
QgsMapToolSelect::QgsMapToolSelect(QgsMapCanvas *Mapcanvas):QgsMapTool(Mapcanvas)
{
   pLayer=NULL;
   mCursor=Qt::ArrowCursor;
   mCanvas=Mapcanvas;
   StatusFlag=true;
   isShowFlag = true;
   mIdentifyResultDlg = NULL;
}

QgsMapToolSelect::~QgsMapToolSelect(void)
{
}
//设置当前被选择(活动)的图层
void QgsMapToolSelect::SetSelectLayer(QgsVectorLayer *Layer)
{
   pLayer=Layer;
}

//鼠标按钮释放时,选择包含鼠标位置的图元
void QgsMapToolSelect::canvasReleaseEvent(QMouseEvent * e )
{
   if(mCanvas==NULL){
       return;
   }
   if(pLayer==NULL){
       QMessageBox::about(mCanvas,QString::fromLocal8Bit("警告"),QString::fromLocal8Bit("请选择图层"));
       return;
   }
   if(StatusFlag==false){
       return;
   }
   //得到产生事件的按钮信息
   Qt::MouseButton mButton=e-&gt;button();
   //如果不是左按钮返回
   if(mButton!=Qt::MouseButton::LeftButton){
       return;
   }
   //得到鼠标指针的位置
   QPoint pos=e-&gt;pos();
   //定义QgsRubberBand对象
   QgsRubberBand rubberBand(mCanvas,true);
   QRect selectRect(,,,);
   //设置鼠标位置区域
   ExpandSelectRangle(selectRect,pos);
   //将鼠标位置区域转换成地图坐标
   SetRubberBand(selectRect,&amp;rubberBand );
   //将QgsRubberBand对象转换为几何对象，根据该几何对象在图层中选择特征
   QgsGeometry* selectGeom=rubberBand.asGeometry();
   if(!selectGeom){
       return;
   }
   //确定是否按下ctrl键
   bool doDifference=e-&gt;modifiers()&amp;Qt::ControlModifier ? true:false;
   //在图层中选择最靠近几何对象的特征
   SetSelectFeatures(selectGeom,false,doDifference,true);
   //SetSelectFeatures(selectGeom,doDifference);

   //设定选择的特征
   pLayer-&gt;setSelectedFeatures(layerSelectedFeatures);
   list = GetAttributeValue(pLayer, layerSelectedFeatures);

   if (isShowFlag)
   {
       ResultDlg()-&gt;InitialData(list);
       ResultDlg()-&gt;show();
   }
   else
   {
       QMessageBox::information(NULL, tr("警告"), tr("请选择矢量图层"), QMessageBox::Ok);
   }
   delete selectGeom;
   rubberBand.reset(true);

}
//提取鼠标位置一定范围作为选择区域
void QgsMapToolSelect::ExpandSelectRangle(QRect &amp;Rect,QPoint Point)
{
   ;
   //如果图层不是面图元类型
   if(pLayer-&gt;geometryType()!=QGis::Polygon){
       boxSize=;
   }
   else{
       boxSize=;
   }
   //设置选择区域
   Rect.setLeft(Point.x()-boxSize);
   Rect.setRight(Point.x()+boxSize);
   Rect.setTop(Point.y()-boxSize);
   Rect.setBottom(Point.y()+boxSize);
}
//将指定的设备坐标区域转换成地图坐标区域
void QgsMapToolSelect::SetRubberBand(QRect &amp;selectRect,QgsRubberBand *pRubber)
{
    //得到当前坐标变换对象
    const QgsMapToPixel* transform=mCanvas-&gt;getCoordinateTransform();
    //将区域设备坐标转换成地图坐标
    QgsPoint ll=transform-&gt;toMapCoordinates(selectRect.left(),selectRect.bottom());
    QgsPoint ur = transform-&gt;toMapCoordinates(selectRect.right(),selectRect.top());
    pRubber-&gt;reset(true );
    //将区域的4个角点添加到QgsRubberBand对象中
    pRubber-&gt;addPoint(ll,false );
    pRubber-&gt;addPoint(QgsPoint(ur.x(), ll.y()),false );
    pRubber-&gt;addPoint(ur,false );
    pRubber-&gt;addPoint(QgsPoint( ll.x(), ur.y() ),true );
}
//选择几何特征
//selectGeometry:选择特征的选择几何体
//doContains：选择的特征是否包含在选择几何体内部
//singleSelect：仅仅选择和选择几何体最靠近的特征
void QgsMapToolSelect::SetSelectFeatures(QgsGeometry *selectGeometry,bool doContains,
                                         bool doDifference,bool singleSelect)
{
    //如果选择几何体不是多边形
    if(selectGeometry-&gt;type()!=QGis::Polygon){
      return;
    }
    QgsGeometry selectGeomTrans(*selectGeometry);
    //设定选择几何体的坐标系和图层的坐标系一致
    if(mCanvas-&gt;mapRenderer()-&gt;hasCrsTransformEnabled()){
       try{
           //将地图绘板坐标系变换到图层坐标系
           QgsCoordinateTransform ct(mCanvas-&gt;mapRenderer()-&gt;destinationSrs(),pLayer-&gt;crs());
           //设定几何体的坐标系和图层坐标系一致
           selectGeomTrans.transform(ct);
       }
       //对于异常点抛出异常
       catch(QgsCsException &amp;cse){
          Q_UNUSED(cse);
          //catch exception for 'invalid' point and leave existing selection unchanged
          QMessageBox::warning(mCanvas, QObject::tr("CRS Exception"),
                            QObject::tr( "Selection extends beyond layer's coordinate system." ) );
          return;
       }
    }
    //设置光标
    //QApplication::setOverrideCursor(Qt::WaitCursor);
    //选择和选择几何体相交或在几何体内部的特征
    pLayer-&gt;select(QgsAttributeList(),selectGeomTrans.boundingBox(),true,true);
    int nh=pLayer-&gt;selectedFeatureCount();
    QgsFeatureIds newSelectedFeatures;
    QgsFeature f;
    ;
    bool foundSingleFeature=false;
    double closestFeatureDist=std::numeric_limits&lt;double&gt;::max();
    //得到当前选择的特征
    while(pLayer-&gt;nextFeature(f)){
       QgsGeometry* g=f.geometry();
       //g是否包含在selectGeomTrans几何体内部
       if(doContains &amp;&amp; !selectGeomTrans.contains(g)){
           continue;
       }
       if(singleSelect){ //选择和几何体最靠近的特征
          foundSingleFeature=true;
          //计算两个几何体之间的距离
          double distance=g-&gt;distance(selectGeomTrans);
          if(distance&lt;=closestFeatureDist){
              closestFeatureDist=distance;
              //计算出最靠近选择几何体特征的id
              closestFeatureId=f.id();
          }
       }
       else{ //存储符合要求的特征id
          newSelectedFeatures.insert(f.id());
       }
   }
   //确定和选择几何体最靠近特征的id
   if(singleSelect &amp;&amp; foundSingleFeature){
       newSelectedFeatures.insert(closestFeatureId);
   }
   //如果按下ctrl键,选择多个特征
   if(doDifference){
       //得到所有选择特征的id
       layerSelectedFeatures=pLayer-&gt;selectedFeaturesIds();
       QgsFeatureIds::const_iterator i=newSelectedFeatures.constEnd();
       while(i!=newSelectedFeatures.constBegin()){
           --i;
           if(layerSelectedFeatures.contains(*i)){
               layerSelectedFeatures.remove( *i );
           }
           else{
               layerSelectedFeatures.insert( *i );
           }
       }
  }
  else{
      layerSelectedFeatures=newSelectedFeatures;
  }

  //QApplication::restoreOverrideCursor();
}
//选择几何特征,用于选择面状几何特征
//selectGeometry:选择几何体
void QgsMapToolSelect::SetSelectFeatures(QgsGeometry *selectGeometry,bool doDifference)
{
    //如果选择几何体不是多边形
    if(selectGeometry-&gt;type()!=QGis::Polygon){
      return;
    }
    QgsGeometry selectGeomTrans(*selectGeometry);
    //设定选择几何体的坐标系和图层的坐标系一致
    if(mCanvas-&gt;mapRenderer()-&gt;hasCrsTransformEnabled()){
       try{
           //将地图绘板坐标系变换到图层坐标系
           QgsCoordinateTransform ct(mCanvas-&gt;mapRenderer()-&gt;destinationSrs(),pLayer-&gt;crs());
           //设定几何体的坐标系和图层坐标系一致
           selectGeomTrans.transform(ct);
       }
       //对于异常点抛出异常
       catch(QgsCsException &amp;cse){
          Q_UNUSED(cse);
          //catch exception for 'invalid' point and leave existing selection unchanged
          QMessageBox::warning(mCanvas, QObject::tr("CRS Exception"),
                            QObject::tr( "Selection extends beyond layer's coordinate system." ) );
          return;
       }
    }
    //设置光标
    //QApplication::setOverrideCursor(Qt::WaitCursor);
    //选择和选择几何体相交或在几何体内部的特征
    pLayer-&gt;select(QgsAttributeList(),selectGeomTrans.boundingBox(),true,true);
    int nh=pLayer-&gt;selectedFeatureCount();
    QgsFeatureIds newSelectedFeatures;
    QgsFeature f;

    ;
    //得到当前选择的特征
    while(pLayer-&gt;nextFeature(f)){
        p++;
       QgsGeometry* g=f.geometry();
       //选择的特征是否包含在选择几何体的内部
       //如果g包含selectGeomTrans，返回true
       if(!g-&gt;contains(&amp;selectGeomTrans)){
           continue;
       }
       //存储符合条件图层特征id
       newSelectedFeatures.insert(f.id());
   }
   QgsFeatureIds layerSelectedFeatures;
   //如果按下ctrl键，可以选择多个特征
   if(doDifference){
       layerSelectedFeatures=pLayer-&gt;selectedFeaturesIds();
       QgsFeatureIds::const_iterator i = newSelectedFeatures.constEnd();
       while( i != newSelectedFeatures.constBegin()){
           --i;
          if( layerSelectedFeatures.contains( *i ) )
          {
             layerSelectedFeatures.remove( *i );
          }
          else
          {
             layerSelectedFeatures.insert( *i );
          }
       }
  }
  else{
     layerSelectedFeatures=newSelectedFeatures;
  }
  //设定选择的特征
  pLayer-&gt;setSelectedFeatures(layerSelectedFeatures);
  //QApplication::restoreOverrideCursor();
}
//设定工具状态
void QgsMapToolSelect::SetEnable(bool flag)
{
    StatusFlag=flag;
    if(StatusFlag){
        mCursor=Qt::CrossCursor;
    }
    else{
        mCursor=Qt::ArrowCursor;
    }
}

IdentifyResultDlg * QgsMapToolSelect::ResultDlg()
{
    if (mIdentifyResultDlg == NULL)
    {
        mIdentifyResultDlg = new IdentifyResultDlg;
    }
    return mIdentifyResultDlg;
}

//得到选择的要素的属性信息
QList&lt;QMap&lt;QString, QString&gt;&gt; QgsMapToolSelect::GetAttributeValue( QgsVectorLayer *layer, QgsFeatureIds selectedFIds )
{
//    QStringList strAttribute;
    QMap&lt;QString, QString&gt; featureValue;
    QList&lt;QMap&lt;QString, QString&gt;&gt; featureValues;
    , nFeatureCount = , nFieldsCount = ;
    if (layer == NULL)
    {
        return featureValues;
    }
    QgsFeatureList featurelist = layer-&gt;selectedFeatures();
    nFeatureCount = featurelist.size();
    QgsFeature feature;
    QString fieldName, fieldValue;
//    vector&lt;QgsField&gt; myFields = layer-&gt;fields();
    ; i &lt; nFeatureCount; i++)
    {
        feature = featurelist.at(i);
        const QgsAttributeMap &amp;attributes = feature.attributeMap();
        nFieldsCount = attributes.count();
        const QgsFieldMap &amp;fields = layer-&gt;pendingFields();//从图层得到字段信息
        QgsField field;
        ; j &lt; nFieldsCount; j++)
        {
            field = fields[j];
            fieldName = field.name();

            fieldValue = attributes[j].toString();
            featureValue.insert(fieldName, fieldValue);
        }
        featureValues.push_back(featureValue);
    }
    return featureValues;
}

void QgsMapToolSelect::setShowFlag( bool flag )
{
    isShowFlag = flag;
}</pre>
</div>
<div>&nbsp;</div>
<p>查询得到的数据显示在对话框：</p>
<p>IdentifyResultDlg对话框是为了显示查询得到的结果。它的定义：</p>
<div>
<pre class="prettyprint linenums">class IdentifyResultDlg : public QDialog
{
    Q_OBJECT

public:
    IdentifyResultDlg(QWidget *parent = );
    ~IdentifyResultDlg();
    void InitialDlg();
    void InitialData(QList&lt;QMap&lt;QString, QString&gt;&gt;);
private:
    Ui::IdentifyResultDlg ui;
    QStandardItemModel *fieldmodel;

};</pre>
</div>
<div>&nbsp;</div>
<p>IdentifyResultDlg具体实现：</p>
<div>
<pre class="prettyprint linenums">#include "identifyresultdlg.h"
IdentifyResultDlg::IdentifyResultDlg(QWidget *parent)
    : QDialog(parent)
{
    ui.setupUi(this);
    QStringList lists;
    InitialDlg();
}
IdentifyResultDlg::~IdentifyResultDlg()
{
}
void IdentifyResultDlg::InitialDlg()
{
    this-&gt;setWindowTitle(tr("查询要素属性信息"));
    fieldmodel = new QStandardItemModel();
    fieldmodel-&gt;setColumnCount();

    ui.tableView-&gt;setModel(fieldmodel);
    ui.tableView-&gt;setEditTriggers(QAbstractItemView::NoEditTriggers);//设置表格不可编辑
    ui.tableView-&gt;verticalHeader()-&gt;hide(); //列头不显示
    ui.tableView-&gt;setSelectionBehavior(QAbstractItemView::SelectRows);//选择整行高亮
    setWindowFlags(Qt::WindowStaysOnTopHint);//使窗口置顶
    , );
}
//将数据显示在表格中
void IdentifyResultDlg::InitialData( QList&lt;QMap&lt;QString, QString&gt;&gt; datas)
{
    fieldmodel-&gt;clear();//注意：在clear之后，表头名称也被清除了，需再设置表头
    fieldmodel-&gt;setHorizontalHeaderItem(, new QStandardItem(QObject::tr("属性名称")));
    fieldmodel-&gt;setHorizontalHeaderItem(, new QStandardItem(QObject::tr("属性值")));

    QString name, value;
    QMap&lt;QString,QString&gt;::iterator it;
    ;
    ; i &lt; datas.count(); i ++)
    {
        QMap&lt;QString,QString&gt; data = datas.at(i);
        ;
        ; it != data.end(), j &lt; data.count(); ++it, ++j)
        {
            int index = i * data.count() +j;
            fieldmodel-&gt;setItem(index, , new QStandardItem(it.key()));
            if (it.value() == NULL)
            {
                it.value() = ";
            }
            fieldmodel-&gt;setItem(index, , new QStandardItem(it.value()));
            fieldmodel-&gt;item(index, )-&gt;setTextAlignment(Qt::AlignCenter);
            fieldmodel-&gt;item(index, )-&gt;setTextAlignment(Qt::AlignCenter);
            )
            {
                fieldmodel-&gt;item(index, )-&gt;setBackground(QBrush(QColor(, , )));
                fieldmodel-&gt;item(index, )-&gt;setBackground(QBrush(QColor(, , )));
            }
        }
    }
}</pre>
</div>
<div>&nbsp;</div>
<p>查询一个要素和多个要素的结果如下图所示：</p>
<p><img referrerpolicy="no-referrer"src="http://img.aiuxian.com/tech/000/001/220/575_925_681.jpg"><img referrerpolicy="no-referrer"src="http://img.aiuxian.com/tech/000/001/220/576_c07_626.jpg"></p>
<p>注意：可能中文字段显示乱码，解决方法：</p>
<p>在操作shp之前，添加这句就可以了：</p>
<div>
<div>
<div>
<div>
<pre class="prettyprint linenums">CPLSetConfigOption("SHAPE_ENCODING","");</pre>
</div>
</div>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7o3vj8.html">MySQL学习笔记十三：表分区</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnw3dkq.html">LTS</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy6jog8.html">【C语言学习】《C Primer Plus》第7章 C控制语句：分支与跳转</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd2xdz9.html">分享一个点赞超过100的漂亮ASP&period;NET MVC蓝色界面框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4r2yj8.html">【Moqui业务逻辑翻译系列】Story of Online Retail Company 在线零售公司的故事</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxpr209.html">UItableView的编辑--删除移动cell</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv7k0jq.html">HTTP层 &mdash;&mdash; 中间件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdey13z9.html">JPush 极光推送 消息推送 实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnvy4z8.html">sqlite3经常使用命令&amp;amp&semi;amp&semi;语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpj6439.html">Xcode中如何集成Unity</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxko4g08.html">10&period;TCP连接的建立与终止</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpkde69.html">201521123081《java程序设计》 第14周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zox5j1q.html">微信小程序项目踩过的几个坑</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2mnd0q.html">EECS 649 Introduction to Artificial Intelligence</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllezy6q.html">斐讯K2 22&period;5&period;9固件刷华硕固件实测教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ojg3k8.html">java&lowbar;有秒计时的数字时钟</a>
		</li>
						<li><a href="https://www.batexi.com/a/8koj4p6q.html">c&num;之hello world</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkr7od8.html">darknet-训练自己的yolov3模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o45oeeq.html">拒绝了对对象 &amp;&num;39&semi;&ast;&ast;&ast;&ast;&amp;&num;39&semi;（数据库 &amp;&num;39&semi;&ast;&ast;&ast;&ast;&ast;&ast;&amp;&num;39&semi;，所有者 &amp;&num;39&semi;&ast;&ast;&ast;&amp;&num;39&semi;）的 SELECT 权限</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em761j9.html">搭建Go调试环境（LiteIDE&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9ge3o0e8.html">HDU 5215  BestCoder&amp;quot&semi;杯中国大学生程序设计冠军赛&rdquo;     边双连通分量取出子图&plus;二分染色判图内奇偶环</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k50w49.html">ZF-关于海南的增删改需求</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzewww8.html">Java中使用poi导入、导出Excel</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpmwjr9.html">As Fast As Possible</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mdor38.html">【贪心】时空定位II</a>
			</li>
						<li><a href="https://www.batexi.com/a/8melmypq.html">更少的直接百度，更多的取看API</a>
			</li>
						<li><a href="https://www.batexi.com/a/950mxxe8.html">Java基于Socket文件传输示例</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojvjlxq.html">winform无法查看设计器</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey50rz9.html">Ueditor的配置及使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/96p7mvy8.html">phpcms v9 在当前栏目下获取父栏目与当前栏目的名称与连接</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
